import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.Arrays;
import java.util.List;

public class Szerializacio {
	public static void main(String[] args) throws FileNotFoundException, IOException, ClassNotFoundException {
		String fileName = "serialized.txt";

		try (
				ObjectOutputStream oos = new ObjectOutputStream(new FileOutputStream(new File(fileName)));
		) {
			Integer ertek = 432531;
			oos.writeObject(ertek);
			
			List<String> szovegek = Arrays.asList("a", "b", "c");
			oos.writeObject(szovegek);

			TesztAdat t2 = new TesztAdat();
			t2.adat = 1232;
			t2.adat2 = "abc2";
			t2.adat3 = null;
			
			TesztAdat t = new TesztAdat();
			t.adat = 123;
			t.adat2 = "abc";
			t.adat3 = t2;

			oos.writeObject(t);
			
			oos.flush();
		}


		try (
				ObjectInputStream ois = new ObjectInputStream(new FileInputStream(new File(fileName)));
		) {
			Integer ertek = (Integer) ois.readObject();
			System.out.println(ertek);
			
			@SuppressWarnings("unchecked")
			List<String> szovegek = (List<String>) ois.readObject();
			System.out.println(szovegek);
		
			TesztAdat t = (TesztAdat)ois.readObject();
			System.out.println(t.adat);
			System.out.println(t.adat2);
			System.out.println(t.adat3.adat);
			System.out.println(t.adat3.adat2);
			System.out.println(t.adat3.adat3);
		}
	}
}
